package ec.gpxml.engine;

import org.jsefa.xml.annotation.XmlAttribute;
import org.jsefa.xml.annotation.XmlDataType;

/**
 * This class is the data holder for statistics of Project, Experiment, Treatment, Trial, Generation,
 * Individual and Representation.<br/>
 * It has setters and getters to all the attributes of Statistics.
 * 
 * <p>It also has the annotations which will be used by <b>jsefa</b>
 * to deserialize statistics XML element to statistics object and 
 * to serialize statistics object to statistics XML element.
 * 
 * @author dharani
 *
 */
@XmlDataType(defaultElementName = "stats")
public class Statistics {
	
	/** Name of the measure */
	@XmlAttribute()
    private String name;	
	
	/** Value of the measure */
	@XmlAttribute()
    private String value;
	
	/**
	 * Sets all the attributes of this class.
	 * This method is just for convenience to set all attributes at once instead of setting one by one.
	 * Null is passed if an attribute doesn't need to be set.
	 * 
	 * @param name the name of the measure
	 * @param value the value of the measure to set
	 */
	public void setAttributes(String name, String value)
	{
		this.name = name;
		this.value = value;
	}

	/**
	 * Returns the name of the statistics.
	 * @return the name of the measure
	 */
	public String getName() {
		return name;
	}

	/**
	 * Sets the name of the statistics.
	 * @param name the name of the measure to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Returns the value of the statistics.
	 * @return the value of the measure
	 */
	public String getValue() {
		return value;
	}

	/**
	 * Sets the value of the statistics.
	 * @param value the value of the measure to set
	 */
	public void setValue(String value) {
		this.value = value;
	}	
}
