package ec.gpxml.engine;

import java.util.List;

/**
 * This class has the utility methods for XMLGP.
 * 
 * @author dharani
 * 
 */

public final class Util {
	
	/**
	 * Returns experiment for the given id of the experiment.
	 * 
	 * @param project the data holder of project
	 * @param id the id of the experiment
	 * @return the data holder of experiment
	 */
	public static Experiment getExperimentById(Project project, int id) 
	{
		Experiment experiment = null;

		List<Experiment> experiments = project.getExperiments();
		if (null != experiments) 
		{
			experiment = experiments.get(id);
		}

		return experiment;
	}

	/**
	 * Returns treatment for the given id of the treatment.
	 * 
	 * @param experiment the data holder of experiment
	 * @param id the id of the treatment
	 * @return treatment the data holder of treatment
	 */
	public static Treatment getTreatmentById(Experiment experiment, int id) 
	{
		Treatment treatment = null;

		List<Treatment> treatments = experiment.getTreatments();
		if (null != treatments) 
		{
			treatment = treatments.get(id);
		}

		return treatment;
	}
	
	/**
	 * Returns trial for the given id of the trial.
	 * 
	 * @param treatment the data holder of treatment
	 * @param id the id of the trial
	 * @return the data holder of trial
	 */
	public static Trial getTrialtById(Treatment treatment, int id) 
	{
		Trial trial = null;

		List<Trial> trials = treatment.getTrials();
		if (null != trials) 
		{
			trial = trials.get(id);
		}

		return trial;
	}
	
	/**
	 * Returns generation for the given id of the generation.
	 * 
	 * @param trial the data holder of trial
	 * @param id the id of the generation
	 * @return the data holder of generation
	 */
	public static Generation getGenerationtById(Trial trial, int id) 
	{
		Generation generation = null;

		List<Generation> generations = trial.getGenerations();
		if (null != generations) 
		{
			generation = generations.get(id);
		}

		return generation;
	}

	/**
	 * Returns individual for the given id of the individual.
	 * 
	 * @param generation the data holder of individual
	 * @param id the id of the individual
	 * @return the data holder of individual
	 */
	public static Individual getIndividualById(Generation generation, int id) 
	{
		Individual individual = null;

		List<Individual> individuals = generation.getIndividuals();
		if (null != individuals) 
		{
			individual = individuals.get(id);
		}

		return individual;
	}

	/**
	 * Returns representation for the given id of the representation.
	 * 
	 * @param individual the data holder of individual
	 * @param id the id of the representation
	 * @return representation the data holder of representation
	 */
	public Representation getRepresentationById(Individual individual, int id) 
	{
		Representation representation = null;

		List<Representation> representations = individual.getRepresentations();
		if (null != representations) 
		{
			representation = representations.get(id);
		}

		return representation;
	}	
	
	//To do
	public Representation getRepresentationByType(Individual individual, String type) 
	{
		
		return null;
	}
	
	/**
	 * Returns the number of children of a node.
	 * @param node the data holder of node
	 * @return the number of children of the node
	 */
	public int getNumberOfChildren(Node node)
	{
		int numOfChildren = 0;
		
		if(null != node)
		{
			List<Node> children = node.getChildren();
			if(!children.isEmpty())
			{
				children.size();
			}
		}
		
		return numOfChildren;
	}
}